package com.baidu.rtc.videoroom;

import java.nio.ByteBuffer;
import java.util.Timer;
import java.util.TimerTask;
import java.util.concurrent.TimeUnit;

import com.baidu.rtc.RTCI420Buffer;
import com.baidu.rtc.RTCVideoCapture;
import com.baidu.rtc.RTCVideoFrame;

import android.os.SystemClock;
import android.util.Log;

public class myOuterRTCVideoCapture extends RTCVideoCapture {

    RTCCapturerObserver capturerObserver = null;

    private final int frameWidth = 480;
    private final int frameHeight = 640;

    private final Timer timer = new Timer();

    private final TimerTask tickTask = new TimerTask() {
        @Override
        public void run() {
            tick();
        }
    };

    @Override
    public void initialize(RTCCapturerObserver capturerObserver) {
        this.capturerObserver = capturerObserver;
    }

    public void tick() {
        RTCVideoFrame videoFrame = getNextFrame();
        capturerObserver.onFrameCaptured(videoFrame);
        videoFrame.release();
    }

    @Override
    public void dispose() {

    }

    @Override
    public boolean isScreencast() {
        return false;
    }

    @Override
    public void startCapture(int i, int i1, int i2) {
        Log.e("selfVideoCapture", "startCapture.");
        timer.schedule(tickTask, 0, 1000 / 15);
    }

    @Override
    public void stopCapture() {
        timer.cancel();
    }

    @Override
    public void changeCaptureFormat(int i, int i1, int i2) {

    }

    public RTCVideoFrame getNextFrame() {
        final long captureTimeNs = TimeUnit.MILLISECONDS.toNanos(SystemClock.elapsedRealtime());
        final RTCI420Buffer buffer = RTCI420Buffer.allocate(frameWidth, frameHeight);
        final ByteBuffer dataY = buffer.getDataY();
        final ByteBuffer dataU = buffer.getDataU();
        final ByteBuffer dataV = buffer.getDataV();
        final int chromaHeight = (frameHeight + 1) / 2;
        final int sizeY = frameHeight * buffer.getStrideY();
        final int sizeU = chromaHeight * buffer.getStrideU();
        final int sizeV = chromaHeight * buffer.getStrideV();
        //        byte data[] = "dd".getBytes();
        //        buffer.getDataY().put("dd".getBytes());
        //
        //        ByteBuffer b = ByteBuffer.wrap(data);
        //
        //        RTCNV12Buffer buffer1 = new RTCNV12Buffer(frameWidth,frameHeight,frameWidth,
        //        frameHeight,b,null) ;

        //       org.webrtc.NV12Buffer buffer1 = new org.webrtc.NV12Buffer(frameWidth,
        //       frameHeight,frameWidth,frameHeight,dataY,null) ;

        return new RTCVideoFrame(buffer, 0 /* rotation */, captureTimeNs);
    }
    //
    //    public void pushVideo(byte b[]) {
    //        RTCVideoFrame videoFrame = getNextFrame(b);
    //        capturerObserver.onFrameCaptured(videoFrame);
    //        videoFrame.release();
    //    }

}
